unit futureImage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Extctrls, mmsystem;

type
  TfutureImage = class(TImage)
  private
    FPictureOut : TPicture;
    FPictureTemp: TPicture;
    FWAVFileName: string;
    FSound: Boolean;
    FRollOver : Boolean;	
    procedure SetPictureOut(Value : TPicture);
    procedure SetPictureTemp(Value : TPicture);
    property PictureTemp : TPicture read FPictureTemp write SetPictureTemp;
    { Private declarations }
  protected
    procedure CMMouseEnter(var msg : TMessage) ; message CM_MOUSEENTER;
    procedure CMMouseLeave(var msg : TMessage) ; message CM_MOUSELEAVE;
    { Protected declarations }
  public
    constructor Create(AOwner : TComponent) ; override;
    destructor Destroy; override;
    { Public declarations }
  published
    property PictureOut : TPicture read FPictureOut write SetPictureOut;
    property WAVFileName : string read FWAVFileName write FWAVFileName;
    property Sound: Boolean read FSound write FSound;
    property RollOver: Boolean read FRollOver write FRollOver;	
    { Published declarations }
  end;

procedure Register;

implementation

constructor TfutureImage.Create(AOwner : TComponent);
begin
     inherited Create(AOwner);
     FPictureOut:=TPicture.Create;
     FPictureTemp:=TPicture.Create;
end;

destructor TfutureImage.Destroy;
begin
     FPictureOut.Free;
     FPictureTemp.Free;
     inherited Destroy;
end;

procedure TfutureImage.SetPictureOut(Value : TPicture);
begin
     FPictureOut.Assign(Value);
end;

procedure TfutureImage.SetPictureTemp(Value : TPicture);
begin
     FPictureTemp.Assign(Value);
end;

procedure TfutureImage.CMMouseEnter(var Msg: TMessage);
label l1;
begin
     inherited;
     if not Sound then goto l1;
     if WAVFileName<>'' then sndPlaySound(PChar(WAVFileName), SND_ASYNC);
l1:     if not RollOver then Exit;	
     PictureTemp:=Picture;
     Picture:=PictureOut;
end;

procedure TfutureImage.CMMouseLeave(var Msg: TMessage);
begin
     inherited;
     if not RollOver then Exit;	
     Picture:=PictureTemp;
end;

procedure Register;
begin
     RegisterComponents('Samples', [TfutureImage]);
end;

end.
